package iTunesBackup;

import java.awt.Dimension;

import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JTextArea;

import net.miginfocom.swing.MigLayout;
/**
 * Tune Backup
 * (c) 2007 Gabe Albert
 * Gabe Albert - gabeosx (at) yahoo.com - www.gabealbert.info
 * The use and distribution of this work is subject to the terms of the 
 * GNU GPL license.  A full-text copy of the license is available online at
 * http://www.gnu.org/licenses/gpl.txt
 * @author Gabe Albert
 */
public class ErrorViewerController {
	
	private JFrame viewFrame = new JFrame("Tracks Not Copied");
	private JPanel viewPanel = new JPanel(new MigLayout("fillx"));
	private JScrollPane scrollPane;// = new JScrollPane();
	private TrackCollection brokenTracks = new TrackCollection();
	public ErrorViewerController(TrackCollection brokenTracks) {
		this.brokenTracks=brokenTracks;
		createAndShowGui();
	}
	
	private void createAndShowGui() {
		viewPanel.add(new JLabel("The following tracks were not copied: "), "wrap");
		for(int i=0; i<brokenTracks.size(); i++) {
			viewPanel.add(getErrorPanel(brokenTracks.get(i)), "wrap");
		}
		scrollPane = new JScrollPane(viewPanel);
		viewFrame.add(scrollPane);
		viewFrame.setPreferredSize(new Dimension(500, 300));
		viewFrame.pack();
		viewFrame.setVisible(true);
	}
	
	private JPanel getErrorPanel(MusicTrack theTrack) {
		JPanel tempPanel = new JPanel(new MigLayout("fillx"));
		JTextArea errorMessage = new JTextArea(5, 20);
		errorMessage.setText(theTrack.getErrorMessage());
		errorMessage.setEditable(false);
		
		JLabel trackLabel = new JLabel("Song: "+theTrack.getTrackArtist()+" - "+theTrack.getTrackName());
		tempPanel.add(trackLabel, "wrap");
		tempPanel.add(errorMessage, "wrap");
		return tempPanel;
	}
}
